%define anolis_release 2
%bcond_with bugzilla

Name: libreport
Summary: Generic library for reporting various problems
Version: 2.17.6
Release: %{anolis_release}%{?dist}
License: GPLv2+
URL: https://abrt.readthedocs.org/
Source: https://github.com/abrt/%{name}/archive/refs/tags/%{version}.tar.gz
BuildRequires: autoconf automake make doxygen gettext libtool
BuildRequires: pkgconfig(augeas) pkgconfig(gio-2.0) >= 2.43.4
BuildRequires: pkgconfig(gio-unix-2.0) >= 2.43.4 pkgconfig(glib-2.0) >= 2.43.4
BuildRequires: pkgconfig(gobject-2.0) pkgconfig(gtk+-3.0)
BuildRequires: pkgconfig(libarchive) pkgconfig(libcurl)
BuildRequires: pkgconfig(libnewt) pkgconfig(libsystemd)
BuildRequires: pkgconfig(libxml-2.0) pkgconfig(satyr)
BuildRequires: python%{python3_pkgversion}-devel
BuildRequires: glibc-all-langpacks
BuildRequires: intltool >= 0.35.0
BuildRequires: /usr/bin/asciidoc /usr/bin/augparse /usr/bin/xmlto
%if %{with bugzilla}
BuildRequires: xmlrpc-c-devel
%endif
Requires: %{name}-filesystem = %{version}-%{release} glib2 >= 2.43.4
Obsoletes: %{name}-compat < 2.13.2 %{name}-plugin-rhtsupport < 2.13.2 %{name}-rhel < 2.13.2

%description
Libraries providing API for reporting different problems in applications
to different bug targets like Bugzilla, ftp, trac, etc...

%package filesystem
Summary: Filesystem layout for %{name}
BuildArch: noarch

%description filesystem
Filesystem layout for %{name}

%package devel
Summary: Development libraries and headers for %{name}
Requires: %{name} = %{version}-%{release}

%description devel
Development libraries and headers for %{name}

%package web
Summary: Library providing network API for %{name}
Requires: %{name} = %{version}-%{release}

%description web
Library providing network API for %{name}

%package web-devel
Summary: Development headers for %{name}-web
Requires: %{name}-web = %{version}-%{release}

%description web-devel
Development headers for %{name}-web

%package -n python%{python3_pkgversion}-%{name}
Summary: Python 3 bindings for report-libs
Requires: %{name} = %{version}-%{release}
Requires: python%{python3_pkgversion}-dnf
%{?python_provide:%python_provide python%{python3_pkgversion}-%{name}}

%description -n python%{python3_pkgversion}-%{name}
Python 3 bindings for report-libs.

%package cli
Summary: %{name}'s command line interface
Requires: %{name} = %{version}-%{release}

%description cli
This package contains simple command line tool for working
with problem dump reports

%package newt
Summary: %{name}'s newt interface
Requires: %{name} = %{version}-%{release}
Provides: report-newt = 0:0.23-1
Obsoletes: report-newt < 0:0.23-1

%description newt
This package contains a simple newt application for reporting
bugs

%package gtk
Summary: GTK front-end for %{name}
Requires: %{name} = %{version}-%{release}
Requires: %{name}-plugin-reportuploader = %{version}-%{release}
Provides: report-gtk = 0:0.23-1
Obsoletes: report-gtk < 0:0.23-1

%description gtk
Applications for reporting bugs using %{name} backend

%package gtk-devel
Summary: Development libraries and headers for %{name}
Requires: %{name}-gtk = %{version}-%{release}

%description gtk-devel
Development libraries and headers for %{name}-gtk

%package plugin-kerneloops
Summary: %{name}'s kerneloops reporter plugin
Requires: %{name} = %{version}-%{release}
Requires: %{name}-web = %{version}-%{release}
Requires: curl

%description plugin-kerneloops
This package contains plugin which sends kernel crash information to specified
server, usually to kerneloops.org.

%package plugin-logger
Summary: %{name}'s logger reporter plugin
Requires: %{name} = %{version}-%{release}

%description plugin-logger
The simple reporter plugin which writes a report to a specified file.

%package plugin-systemd-journal
Summary: %{name}'s systemd journal reporter plugin
Requires: %{name} = %{version}-%{release}

%description plugin-systemd-journal
The simple reporter plugin which writes a report to the systemd journal.

%package plugin-mailx
Summary: %{name}'s mailx reporter plugin
Requires: %{name} = %{version}-%{release}
Requires: /usr/bin/mailx

%description plugin-mailx
The simple reporter plugin which sends a report via mailx to a specified
email address.

%if %{with bugzilla}
%package plugin-bugzilla
Summary: %{name}'s bugzilla plugin
Requires: %{name} = %{version}-%{release}
Requires: %{name}-web = %{version}-%{release}

%description plugin-bugzilla
Plugin to report bugs into the bugzilla.
%endif

%package plugin-mantisbt
Summary: %{name}'s mantisbt plugin
Requires: %{name} = %{version}-%{release}
Requires: %{name}-web = %{version}-%{release}

%description plugin-mantisbt
Plugin to report bugs into the mantisbt.

%package plugin-ureport
Summary: %{name}'s micro report plugin
BuildRequires: pkgconfig(json-c)
Requires: %{name} = %{version}-%{release}
Requires: %{name}-web = %{version}-%{release}

%description plugin-ureport
Uploads micro-report to abrt server

%package plugin-reportuploader
Summary: %{name}'s reportuploader plugin
Requires: %{name} = %{version}-%{release}
Requires: %{name}-web = %{version}-%{release}

%description plugin-reportuploader
Plugin to report bugs into anonymous FTP site associated with ticketing system.

%if %{with bugzilla}
%package anaconda
Summary: Default configuration for reporting anaconda bugs
Requires: %{name} = %{version}-%{release}
Requires: %{name}-plugin-reportuploader = %{version}-%{release}
Requires: %{name}-plugin-bugzilla = %{version}-%{release}

%description anaconda
Default configuration for reporting Anaconda problems or uploading the gathered
data over ftp/scp...
%endif

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1

%build
autoreconf -fi
%configure \
%if %{without bugzilla}
        --without-bugzilla \
%endif
        --disable-silent-rules \
        --disable-static \
        --enable-doxygen-docs

%make_build

%install
%make_install

%find_lang %{name}

mkdir -p %{buildroot}/%{_initrddir}
mkdir -p %{buildroot}/%{_sysconfdir}/%{name}/events.d/
mkdir -p %{buildroot}/%{_sysconfdir}/%{name}/events/
mkdir -p %{buildroot}/%{_sysconfdir}/%{name}/workflows.d/
mkdir -p %{buildroot}/%{_datadir}/%{name}/events/
mkdir -p %{buildroot}/%{_datadir}/%{name}/workflows/

rm -f %{buildroot}/%{_datadir}/doc/%{name}/README.md

rm -f %{buildroot}/%{_datadir}/%{name}/workflows/workflow_Fedora*.xml
rm -f %{buildroot}/%{_datadir}/%{name}/workflows/workflow_AnacondaFedora.xml

rm -f %{buildroot}/%{_datadir}/%{name}/workflows/workflow_RHEL*.xml
rm -f %{buildroot}/%{_datadir}/%{name}/workflows/workflow_AnacondaRHELBugzilla.xml

rm -f %{buildroot}%{_datadir}/%{name}/workflows/workflow_CentOS*.xml
rm -f %{buildroot}%{_datadir}/%{name}/events/report_CentOSBugTracker.xml

rm -f %{buildroot}%{_sysconfdir}/%{name}/events/*{Fedora,fedora,CentOS,centos,RHEL,rhel}*.conf
rm -f %{buildroot}%{_sysconfdir}/%{name}/events.d/*{Fedora,fedora,CentOS,centos,RHEL,rhel}*.conf
rm -f %{buildroot}%{_sysconfdir}/%{name}/workflows.d/*{Fedora,fedora,CentOS,centos,RHEL,rhel}*.conf
rm -f %{buildroot}%{_mandir}/man5/*{Fedora,fedora,CentOS,centos,RHEL,rhel}*.conf.5

%if %{without bugzilla}
rm -f  %{buildroot}%{_mandir}/man5/anaconda_event.conf.5
%endif

%generate_compatibility_deps

%check
%make_build check || {
    find tests/testsuite.dir -name "testsuite.log" -print -exec cat '{}' \;
    exit 1
}

%files -f %{name}.lang
%license COPYING
%dir %{abidir}
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}/report_event.conf
%config(noreplace) %{_sysconfdir}/%{name}/forbidden_words.conf
%config(noreplace) %{_sysconfdir}/%{name}/ignored_words.conf
%config(noreplace) %{_sysconfdir}/%{name}/ignored_elements.conf
%{_datadir}/%{name}/conf.d/%{name}.conf
%{_libdir}/%{name}.so.*
%{abidir}/%{name}.dump
%{_mandir}/man5/%{name}.conf.5*
%{_mandir}/man5/report_event.conf.5*
%{_mandir}/man5/forbidden_words.conf.5*
%{_mandir}/man5/ignored_words.conf.5*
%{_mandir}/man5/ignored_elements.conf.5*
%{_datadir}/augeas/lenses/%{name}.aug

%files filesystem
%dir %{_sysconfdir}/%{name}/
%dir %{_sysconfdir}/%{name}/events.d/
%dir %{_sysconfdir}/%{name}/events/
%dir %{_sysconfdir}/%{name}/workflows.d/
%dir %{_datadir}/%{name}/
%dir %{_datadir}/%{name}/conf.d/
%dir %{_datadir}/%{name}/conf.d/plugins/
%dir %{_datadir}/%{name}/events/
%dir %{_datadir}/%{name}/workflows/
%dir %{_sysconfdir}/%{name}/plugins/

%files devel
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/%{name}_types.h
%{_includedir}/%{name}/client.h
%{_includedir}/%{name}/dump_dir.h
%{_includedir}/%{name}/event_config.h
%{_includedir}/%{name}/problem_data.h
%{_includedir}/%{name}/problem_report.h
%{_includedir}/%{name}/report.h
%{_includedir}/%{name}/report_result.h
%{_includedir}/%{name}/run_event.h
%{_includedir}/%{name}/file_obj.h
%{_includedir}/%{name}/config_item_info.h
%{_includedir}/%{name}/workflow.h
%{_includedir}/%{name}/problem_details_widget.h
%{_includedir}/%{name}/problem_details_dialog.h
%{_includedir}/%{name}/problem_utils.h
%{_includedir}/%{name}/ureport.h
%{_includedir}/%{name}/reporters.h
%{_includedir}/%{name}/global_configuration.h
%{_includedir}/%{name}/internal_%{name}.h
%{_includedir}/%{name}/xml_parser.h
%{_includedir}/%{name}/helpers
%{_libdir}/%{name}.so
%{_libdir}/pkgconfig/%{name}.pc
%doc apidoc/html/*.{html,png,css,js}

%files web
%{_libdir}/%{name}-web.so.*
%{abidir}/%{name}-web.dump

%files web-devel
%{_libdir}/%{name}-web.so
%{_includedir}/%{name}/%{name}_curl.h
%{_libdir}/pkgconfig/%{name}-web.pc

%files -n python%{python3_pkgversion}-%{name}
%{python3_sitearch}/report/
%{python3_sitearch}/reportclient/
%{abidir}/_py3report.dump
%{abidir}/_reportclient3.dump

%files cli
%{_bindir}/report-cli
%{_mandir}/man1/report-cli.1.*

%files newt
%{_bindir}/report-newt
%{_mandir}/man1/report-newt.1.*

%files gtk
%{_bindir}/report-gtk
%{_libdir}/%{name}-gtk.so.*
%{abidir}/%{name}-gtk.dump
%{_mandir}/man1/report-gtk.1.*

%files gtk-devel
%{_libdir}/%{name}-gtk.so
%{_includedir}/%{name}/internal_%{name}_gtk.h
%{_libdir}/pkgconfig/%{name}-gtk.pc

%files plugin-kerneloops
%{_datadir}/%{name}/events/report_Kerneloops.xml
%{_mandir}/man*/reporter-kerneloops.*
%{_bindir}/reporter-kerneloops

%files plugin-logger
%config(noreplace) %{_sysconfdir}/%{name}/events/report_Logger.conf
%{_mandir}/man5/report_Logger.conf.5.*
%{_datadir}/%{name}/events/report_Logger.xml
%{_datadir}/%{name}/workflows/workflow_Logger*.xml
%config(noreplace) %{_sysconfdir}/%{name}/events.d/print_event.conf
%config(noreplace) %{_sysconfdir}/%{name}/workflows.d/report_logger.conf
%{_mandir}/man5/print_event.conf.5.*
%{_mandir}/man5/report_logger.conf.5.*
%{_bindir}/reporter-print
%{_mandir}/man*/reporter-print.*

%files plugin-systemd-journal
%{_bindir}/reporter-systemd-journal
%{_mandir}/man*/reporter-systemd-journal.*

%files plugin-mailx
%config(noreplace) %{_sysconfdir}/%{name}/plugins/mailx.conf
%{_datadir}/%{name}/conf.d/plugins/mailx.conf
%{_datadir}/%{name}/events/report_Mailx.xml
%{_datadir}/%{name}/workflows/workflow_Mailx*.xml
%config(noreplace) %{_sysconfdir}/%{name}/events.d/mailx_event.conf
%config(noreplace) %{_sysconfdir}/%{name}/workflows.d/report_mailx.conf
%{_mandir}/man5/mailx.conf.5.*
%{_mandir}/man5/mailx_event.conf.5.*
%{_mandir}/man5/report_mailx.conf.5.*
%{_mandir}/man*/reporter-mailx.*
%{_bindir}/reporter-mailx

%files plugin-ureport
%config(noreplace) %{_sysconfdir}/%{name}/plugins/ureport.conf
%{_datadir}/%{name}/conf.d/plugins/ureport.conf
%{_bindir}/reporter-ureport
%{_mandir}/man1/reporter-ureport.1.*
%{_mandir}/man5/ureport.conf.5.*
%{_datadir}/%{name}/events/report_uReport.xml
%config(noreplace) %{_sysconfdir}/%{name}/workflows.d/report_uReport.conf
%{_datadir}/%{name}/workflows/workflow_uReport.xml
%{_mandir}/man5/report_uReport.conf.5.*

%if %{with bugzilla}
%files plugin-bugzilla
%config(noreplace) %{_sysconfdir}/%{name}/plugins/bugzilla.conf
%{_datadir}/%{name}/conf.d/plugins/bugzilla.conf
%config(noreplace) %{_sysconfdir}/%{name}/plugins/bugzilla_format.conf
%config(noreplace) %{_sysconfdir}/%{name}/plugins/bugzilla_formatdup.conf
%config(noreplace) %{_sysconfdir}/%{name}/plugins/bugzilla_format_analyzer_%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}/plugins/bugzilla_formatdup_analyzer_%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}/plugins/bugzilla_format_kernel.conf
%{_datadir}/%{name}/events/report_Bugzilla.xml
%{_datadir}/%{name}/events/watch_Bugzilla.xml
%config(noreplace) %{_sysconfdir}/%{name}/events/report_Bugzilla.conf
%config(noreplace) %{_sysconfdir}/%{name}/events.d/bugzilla_event.conf
%{_mandir}/man1/reporter-bugzilla.1.*
%{_mandir}/man5/report_Bugzilla.conf.5.*
%{_mandir}/man5/bugzilla_event.conf.5.*
%{_mandir}/man5/bugzilla.conf.5.*
%{_mandir}/man5/bugzilla_format.conf.5.*
%{_mandir}/man5/bugzilla_formatdup.conf.5.*
%{_mandir}/man5/bugzilla_format_analyzer_%{name}.conf.5.*
%{_mandir}/man5/bugzilla_formatdup_analyzer_%{name}.conf.5.*
%{_mandir}/man5/bugzilla_format_kernel.conf.5.*
%{_bindir}/reporter-bugzilla
%endif

%files plugin-mantisbt
%config(noreplace) %{_sysconfdir}/%{name}/plugins/mantisbt.conf
%{_datadir}/%{name}/conf.d/plugins/mantisbt.conf
%config(noreplace) %{_sysconfdir}/%{name}/plugins/mantisbt_format.conf
%config(noreplace) %{_sysconfdir}/%{name}/plugins/mantisbt_formatdup.conf
%config(noreplace) %{_sysconfdir}/%{name}/plugins/mantisbt_format_analyzer_%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}/plugins/mantisbt_formatdup_analyzer_%{name}.conf
%{_bindir}/reporter-mantisbt
%{_mandir}/man1/reporter-mantisbt.1.*
%{_mandir}/man5/mantisbt.conf.5.*
%{_mandir}/man5/mantisbt_format.conf.5.*
%{_mandir}/man5/mantisbt_formatdup.conf.5.*
%{_mandir}/man5/mantisbt_format_analyzer_%{name}.conf.5.*
%{_mandir}/man5/mantisbt_formatdup_analyzer_%{name}.conf.5.*

%files plugin-reportuploader
%{_mandir}/man*/reporter-upload.*
%{_mandir}/man5/uploader_event.conf.5.*
%{_bindir}/reporter-upload
%{_datadir}/%{name}/events/report_Uploader.xml
%config(noreplace) %{_sysconfdir}/%{name}/events.d/uploader_event.conf
%{_datadir}/%{name}/workflows/workflow_Upload*.xml
%config(noreplace) %{_sysconfdir}/%{name}/plugins/upload.conf
%{_datadir}/%{name}/conf.d/plugins/upload.conf
%{_mandir}/man5/upload.conf.5.*
%config(noreplace) %{_sysconfdir}/%{name}/workflows.d/report_uploader.conf
%{_mandir}/man5/report_uploader.conf.5.*
%config(noreplace) %{_sysconfdir}/%{name}/events/report_Uploader.conf
%{_mandir}/man5/report_Uploader.conf.5.*

%if %{with bugzilla}
%files anaconda
%{_datadir}/%{name}/workflows/workflow_AnacondaUpload.xml
%config(noreplace) %{_sysconfdir}/%{name}/workflows.d/anaconda_event.conf
%config(noreplace) %{_sysconfdir}/%{name}/events.d/bugzilla_anaconda_event.conf
%config(noreplace) %{_sysconfdir}/%{name}/plugins/bugzilla_format_anaconda.conf
%config(noreplace) %{_sysconfdir}/%{name}/plugins/bugzilla_formatdup_anaconda.conf
%{_mandir}/man5/anaconda_event.conf.5.*
%{_mandir}/man5/bugzilla_anaconda_event.conf.5.*
%{_mandir}/man5/bugzilla_format_anaconda.conf.5.*
%{_mandir}/man5/bugzilla_formatdup_anaconda.conf.5.*
%endif

%files doc
%doc HACKING.md README.md CHANGELOG.md INSTALL

%changelog
* Tue Apr 11 2023 Shawn Wang <shawnwang@linux.alibaba.com> - 2.17.6-2
- Optimize the spec file

* Mon Jan 30 2023 Funda Wang <fundawang@yeah.net> - 2.17.6-1
- New version 2.17.6

* Thu Oct 20 2022 happy_orange <songnannan@linux.alibaba.com> - 2.17.1-2
- add doc package and add api.

* Mon May 16 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.17.1-1
- init from upstream
